/***************************************************************************
 web_server.c  -  a web server wich is more (or less) than only a web server
                             -------------------
    begin                : ????????????????
    copyright            : (C) 2002 by Mirko De Grandis
    email                : dega_mi@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <time.h>
#include <signal.h>
#include <dirent.h>
#include <fcntl.h>
#include <sched.h>
#include "file.jpg.c"
#include "directory.jpg.c"
#include "styles.css.c"

#define BUFSIZE 32768
#define VERSION "v.0.0.7"
#define AUTHOR "Written and copyrights by Mirko De Grandis."
#define KILO 1024
#define MEGA (1024*1024)
#define GIGA (1024*1024*1024)

#define PDEBUG 0
#define HAPPYHEAD  "HTTP/1.1 200 OK\nConnection: close\nContent/Type: text/html\n\n"
#define HAPPYMSG  "<HTML><HEAD><TITLE>BE HAPPY</TITLE></HEAD><BODY bgcolor=#deeae4><FONT size=+8 color=#ef280e><U><B>Alert!! Alert!!</B></U></FONT><FONT size=+4><BR>&nbsp;<BR>&nbsp;<BR><B>WINDOZ DETECTED!!!!!!</B><BR>this is not for you kid! :)</FONT></BODY></HTML>\n"

typedef struct{
  char* action;          //what the client wants
  char* what;            //what the action interest
  char* host;            //Host line
  char* agent;           //the client user-agent
  char* accept;          //accept line
  char* lang;            //accept-language line
  char* enc;             //accept-encoding line
  char* charset;         //accept-charset line
  char* keep;            //keep-alive line;
  char* conn;            //connection line;
  char* referer;         //referer page
  char* pragma;          //pragma line
  char* contType;        //content-type line   (se il browser invia qualche info)
  char* contLength;      //content-lenght line (idem)
  char* content;         //quello che viene inviato
}req_descriptor;


unsigned char ret_buf[BUFSIZE];
FILE *logfile;
int n_errno=-1;

int logflag=0;
int DEBUG=0;
int MYPORT=8000;    /* the port users will be connecting to */
time_t tempo;
int FORKON=8192;
int CHATMODE=0;
char *rootdir=NULL;
int HAPPYMODE=0;
int programWIDE_totalReceived,programWIDE_totalSent; //per implementare status
pid_t pidPassed;
int ls_follow_outside_links=0;
char *DIRS[100]; //directory in cui posso leggere
FILE *usr_cnsl;  //dove vanno stampati i messaggi di DEBUG
char *ACCEPTED_METHODS[]={"GET","CHA","POST","ping-WsMp3?",NULL};

extern unsigned char file_jpg[file_jpg_bufsize];
extern unsigned char directory_jpg[directory_jpg_bufsize];
extern unsigned char styles_css[styles_css_bufsize];

/********************************************FUNZIONI*************************************/
char *mytime(struct tm *src);
void nop();
int ISMP3(char *nomefile);
int ISHTM(char *nomefile);
int shallIfork(char* filename);
int needHeader(req_descriptor *reqd);
int is_inside(char *path);

void read_mp3_dir(req_descriptor *reqd,int *sock);
void read_mp3_file(req_descriptor *reqd,int *sock);
void read_html_file(req_descriptor *reqd,int *sock);
void dread_html_file(FILE *filedes,int *sock);
void read_any_file(req_descriptor *reqd,int *sock);
int read_file(req_descriptor *reqd,int *sock);
int dread_file(FILE *filedes,char *filetype,int *sock);
void send_dir_list(int sock, req_descriptor *reqd);

char x2c(char *what);
void unescape_url(char *url);
char* nomefile(char *buf,const int msg);

req_descriptor* parse_request(char *req); 
req_descriptor* cpy_req_descriptor(req_descriptor *desc);
void rem_req_descriptor(req_descriptor *desc);
void reinit_req_descriptor(req_descriptor *desc);
char* print_req_descriptor(req_descriptor *desc);

char* get_op(char *buf);
char* gimme_line(char* buf,char* line);
char* gimme_content(char *buf);
char* get_filedesc(char *filename);

char* write_error_msg(req_descriptor *reqd,char *msg);
void menu(int *sock);
void mychildexithandler(int exitStatus);
/****************************************************************************************/

/*
 * quando un figlio del programma esce, il padre richiama questa funzione.
 * se il figlio ha scritto il numero di bytes in entrata ed in uscita nel file wsmp3_result_bytes.tmp
 * i due numeri vengono letti e aggiunti alle variabili programWIDE_totalReceived e programWIDE_totalSent
 * ed il file viene cancellato. il figlio (che intanto e' diventato un processo zombie)
 * viene completamente terminato grazie alla chiamata di waitpid.(nb) exitStatus viene ignorato.
 */
void mychildexithandler(int exitStatus)
{
  char buff[1024];
  char filename[100];
  int i,readnumber;
  FILE *tf;

  if(PDEBUG) printf("In mychildexithandler()\n");
  if(PDEBUG) printf("programWIDE_totalReceived:%d\nprogramWIDE_totalSent:%d\n",
		    programWIDE_totalReceived,programWIDE_totalSent);

  for(i=0;i<100;i++) filename[i]='\0';
  for(i=0;i<1024;i++) buff[i]='\0';
  readnumber=0;
  
  sprintf(filename,"wsmp3_result_bytes.tmp");
  tf=fopen(filename,"r");
  if(tf!=NULL)
    {
      if(PDEBUG) printf("File trovato\n");
      while(!feof(tf))
	{
	  i=fread(buff,1,1024,tf);
	}
      for(i=0;i<(strstr(buff,"/")-buff);i++)
	{ 
	  if(buff[i]>='0' && buff[i]<='9') 
	    readnumber = readnumber*10 + buff[i]-'0';
	}
      programWIDE_totalReceived+=readnumber;

      readnumber=0;
      for(i=i+1;i<strlen(buff);i++)
	{  
	  if(buff[i]>='0' && buff[i]<='9') 
	    readnumber = readnumber*10 + buff[i]-'0';
	}
       programWIDE_totalSent+=readnumber;
    
       if(PDEBUG) printf("programWIDE_totalReceived:%d\nprogramWIDE_totalSent:%d\n",
			 programWIDE_totalReceived,programWIDE_totalSent);

      fclose(tf);
      unlink(filename);
    }
  waitpid(pidPassed,&i,0); //voglio eliminare il processo zombie!!!
  if(PDEBUG) printf("Uscita da mychildexithandler()\n");
}


/*
 * Funzione che visualizza il menu per una connessione di telnet. il timeout e' fissato a 10 secondi
 */
void menu(int *sock)
{
  int i;
  time_t start_tempo;
  char recvBuffer[BUFSIZE];
  char buffer[1024];
  char end[3]={255,253,18};
  char *menuopts[]={"1.Statics\n","2.Set Debug\n","3.Set Logging\n","4.Set Chat\n","5.Quit\n"};
  char showmenu[1024];
  if(PDEBUG) printf("In menu\n");
  fcntl(*sock,F_SETFL,O_NONBLOCK);
  while(1)
    {
      sprintf(showmenu,"\n-> WsMp3 <-\n\n%s%s%s%s%s\n>",
	      menuopts[0],
	      menuopts[1],
	      menuopts[2],
	      menuopts[3],
	      menuopts[4]);
      i=-1;
      send(*sock,showmenu,strlen(showmenu),0);
      time(&start_tempo);
      do
	{  
	  i=recv(*sock,recvBuffer,BUFSIZE,0);
	  if(i!=-1) break;
	  time(&tempo);
	  if((( (int)tempo - (int)start_tempo ))>10) break;
	}while( ((int)tempo - (int)start_tempo )<10 );

      if(i==-1) 
	{
	  if(PDEBUG) printf("Uscito da menu()\n");
	  send(*sock,"TIMEOUT!\n",9,0);
	  send(*sock,end,3,0);
	  return;
	}
      else if(i==3 && recvBuffer[0]=='1')
	{
	  sprintf(showmenu,"rx bytes: %d ,\ttx bytes: %d \nDEBUG:%d, LOGGING:%d, CHATMODE:%d\n",
		  programWIDE_totalReceived,programWIDE_totalSent,DEBUG,logflag,CHATMODE);
	  send(*sock,showmenu,strlen(showmenu),0);
	}
      else if(i==3 && recvBuffer[0]=='2')
	{
	  if(DEBUG) 
	    {
	      send(*sock,"DEBUG is now OFF.\n",strlen("DEBUG is now OFF.\n"),0);
	      DEBUG=0;
	    }
	  else 
	    {    
	      send(*sock,"DEBUG is now ON.\n",strlen("DEBUG is now ON.\n"),0);
	      DEBUG=1;
	      if(CHATMODE)
		{
		  CHATMODE=0;
		  send(*sock,"CHATMODE is now OFF.\n",strlen("CHATMODE is now OFF.\n"),0);
		}
	    }
	}
      else if(i==3 && recvBuffer[0]=='3')
	{
	  if(logflag) 
	    {
	      logflag=0;
	      fclose(logfile);
	      send(*sock,"LOGGING is now OFF.\n",strlen("LOGGING is now OFF.\n"),0);
	    }
	  else
	    {
	      logflag=1;
	      sprintf(buffer,"%s",getenv("PWD"));                     //controllo che la dir corrente
	      if(strstr(buffer,getenv("HOME"))!=buffer)            //sia sotto-dir della mia home
		sprintf(buffer,"%s/wsmp3-logfile.log",getenv("HOME"));  //se si scrivo nella dir
	      else sprintf(buffer,"%s/wsmp3-logfile.log",getenv("PWD"));//se no scrivo nella mia home
	      logfile=fopen(buffer,"a+");
	      if(logfile==NULL)
		{
		  send(*sock,"An error occured.LOGGING is now OFF.\n",
		       strlen("An error occured.LOGGING is now OFF.\n"),0);
		  logflag=0;
		}
	      else send(*sock,"LOGGING is now ON.\n",strlen("LOGGING is now ON.\n"),0);
	    }
	}
      else if(i==3 && recvBuffer[0]=='4')
	{
	  if(CHATMODE)
	    {
	      CHATMODE=0;
	      send(*sock,"CHATMODE is now OFF.\n",strlen("CHATMODE is now OFF.\n"),0);
	    }
	  else
	    {
	      CHATMODE=1;
	      FORKON=0;
	      DEBUG=0;
	      send(*sock,"CHATMODE is now ON.\n",strlen("CHATMODE is now ON.\n"),0);
	    }
	}
      else if(i==3 && recvBuffer[0]=='5')
	{
	  if(PDEBUG) printf("Uscito da menu()\n");
	  send(*sock,"Quitting...\n",12,0);
	  send(*sock,end,3,0);
	  return;
	}
      else
	{
	  send(*sock,
	       "Answer only 1,2,3,4 or 5 please!\n",
	       strlen("Answer only 1,2,3,4 or 5 please!\n")
	       ,0); 
	}
    }
}


/*
 * restituisce un messaggio di errore (in formato html o no)
 */
char* write_error_msg(req_descriptor *reqd,char *msg)
{
  char * ritorno;
  char *errstr[5]={"404 Not Found",
		   "403 Forbidden",
		   "503 Service Unavaible",
		   "501 Not Implemented",
		   "400 Bad Request"};
  int errnum;
  char errhead[1024];
  errnum=0;

  if((ritorno=(char *)malloc(1024))==NULL)
    {
      printf("Not enough memory\n");
      exit(1);
    }
  
  if(strstr(msg,"o such")!=NULL) errnum=0;
  else if(strstr(msg,"denied")!=NULL) errnum=1;
  else if(strstr(msg,"later")!=NULL) errnum=2;
  else if(strstr(msg,"mplemented")!=NULL) errnum=3;
  else errnum=4;
  
  sprintf(errhead,"HTTP/1.1 %s\nConnection: close\nContent/Type: text/html\n\n",
	  errstr[errnum]);


  if(needHeader(reqd))
    sprintf(ritorno,"%s<HTML><HEAD><TITLE>Error</TITLE><BODY><H3>%s%s %s</H3></BODY></HTML>\n",
	    errhead,
	    (reqd!=NULL) ? reqd->what+strlen(rootdir) : "",
	    (reqd!=NULL) ? ":" : "",
	    msg);
  else sprintf(ritorno,"%s%s %s\n",
	       (reqd!=NULL) ? reqd->what+strlen(rootdir) : "",
	       (reqd!=NULL) ? ":" : "",
	       msg);
  n_errno=-1;

  programWIDE_totalSent+=strlen(ritorno);
  return ritorno;
}


/*
 * restituice la descrizione per un header http di un file
 */
char* get_filedesc(char *filename)
{
  char *ritorno=
  (strstr(filename,".htm")!=NULL) ? "text/html" : 
   (strstr(filename,".txt")!=NULL) ? "text/plain" :
    (strstr(filename,".rtx")!=NULL) ? "text/richtext" :
     (strstr(filename,".css")!=NULL) ? "text/css" :
      (strstr(filename,".jpg")!=NULL) ? "image/jpeg" :
       (strstr(filename,".jpe")!=NULL) ? "image/jpeg" :
        (strstr(filename,".jpeg")!=NULL) ? "image/jpeg" :
         (strstr(filename,".gif")!=NULL) ? "image/gif" :
          (strstr(filename,".png")!=NULL) ? "image/png" :
           (strstr(filename,".tif")!=NULL) ? "image/tiff" :
            (strstr(filename,".tiff")!=NULL) ? "image/tiff" :
             (strstr(filename,".xbm")!=NULL) ? "image/x-xbitmap" :
              (strstr(filename,".pdf")!=NULL) ? "application/pdf" :
               (strstr(filename,".ai")!=NULL) ? "application/postscript" :
                (strstr(filename,".eps")!=NULL) ? "application/postscript" :
                 (strstr(filename,".ps")!=NULL) ? "application/postscript" :
                  (strstr(filename,".rtf")!=NULL) ? "application/rtf" :
                   (strstr(filename,".csh")!=NULL) ? "application/x-csh" :
                    (strstr(filename,".tcl")!=NULL) ? "application/x-tcl" :
                     (strstr(filename,".tex")!=NULL) ? "application/x-tex" :
                      (strstr(filename,".zip")!=NULL) ? "application/zip" :
                       (strstr(filename,".bcpio")!=NULL) ? "application/x-bcpio" :
                        (strstr(filename,".cpio")!=NULL) ? "application/x-cpio" :
                         (strstr(filename,".au")!=NULL) ? "audio/basic" :
                          (strstr(filename,".snd")!=NULL) ? "audio/basic" :
                           (strstr(filename,".aif")!=NULL) ? "audio/x-aiff" :
                            (strstr(filename,".aiff")!=NULL) ? "audio/x-aiff" :
                             (strstr(filename,".aifc")!=NULL) ? "audio/x-aiff" :
                              (strstr(filename,".mpeg")!=NULL) ? "video/mpeg" :
                               (strstr(filename,".mpg")!=NULL) ? "video/mpeg" :
                                (strstr(filename,".mpe")!=NULL) ? "video/mpeg" :
                                 (strstr(filename,".qt")!=NULL) ? "video/quicktime" :
                                  (strstr(filename,".mov")!=NULL) ? "video/quicktime" :
                                   (strstr(filename,".avi")!=NULL) ? "x-video/msvideo" :
                                    (strstr(filename,".movie")!=NULL) ? "video/x-sgi-movie" :
    "*/*";
    return ritorno;
}


/*
 * non fa nulla :)
 */
void nop()
{
}


/*
 * se un file ha estensione .mp3 restituisce 1 , 0 altrimenti
 */
int ISMP3(char *nomefile)
{
  if((nomefile[strlen(nomefile)-1]=='3' && 
      (nomefile[strlen(nomefile)-2]=='p' || nomefile[strlen(nomefile)-2]=='P')) && 
     (
      (nomefile[strlen(nomefile)-3]=='m' || nomefile[strlen(nomefile)-3]=='M') && 
       nomefile[strlen(nomefile)-4]=='.'
     )
    ) return 1;
  else return 0;
}


/*
 * se un file ha estensione .htm restituisce 1 , 0 altrimenti
 */
int ISHTM(char *nomefile)
{
  if( 
     (
       (nomefile[strlen(nomefile)-1]=='m' || nomefile[strlen(nomefile)-1]=='M') && 
       (nomefile[strlen(nomefile)-2]=='t' || nomefile[strlen(nomefile)-2]=='T')
     )
      &&
     ( 
      (nomefile[strlen(nomefile)-3]=='h' || nomefile[strlen(nomefile)-3]=='H') && 
      nomefile[strlen(nomefile)-4]=='.'
     )
    ) return 1;
  else return 0;
}


/*
 * se la dimensione del file filename e' 
 * maggiore di FORKON restituisce 1 , 0 altrimenti
 */
int shallIfork(char* filename)
{
  int i;
  char buf[FORKON+1];
  FILE *f;

  if(PDEBUG) printf("Entrato in shallIfork()\n");

  f=fopen(filename,"r");
  if(f==NULL) return 0;
  if((i=fread(buf,1,FORKON+1,f))==FORKON+1) return 1;
  return 0;
}


/*
 * Decide se inviare o no un header http
 */
int needHeader(req_descriptor *reqd)
{
  char *okAgents[]={"ozilla","pera","Wget","Java",NULL};
  char **cp;
  
  if(reqd==NULL) return 1;
  else if(reqd!=NULL && reqd->agent==NULL) return 0;
  else
    { 
      cp=okAgents;
      while(*cp!=NULL)
	{
	  if(strstr(reqd->agent,*cp)!=NULL) return 1;
	  cp++;
	}
    }
  return 0;
}


/*
 * inizializza una struct req_descriptor
 */
void reinit_req_descriptor(req_descriptor *desc)
{
  int i;
  if(desc->action!=NULL)     for(i=0;i<10;i++)   desc->action[i]='\0';
  if(desc->what!=NULL)       for(i=0;i<1024;i++) desc->what[i]='\0';
  if(desc->host!=NULL)       for(i=0;i<1024;i++) desc->host[i]='\0';
  if(desc->agent!=NULL)      for(i=0;i<1024;i++) desc->agent[i]='\0';
  if(desc->accept!=NULL)     for(i=0;i<1024;i++) desc->accept[i]='\0';
  if(desc->lang!=NULL)       for(i=0;i<1024;i++) desc->lang[i]='\0';
  if(desc->enc!=NULL)        for(i=0;i<1024;i++) desc->enc[i]='\0';
  if(desc->charset!=NULL)    for(i=0;i<1024;i++) desc->charset[i]='\0';
  if(desc->keep!=NULL)       for(i=0;i<1024;i++) desc->keep[i]='\0';
  if(desc->conn!=NULL)       for(i=0;i<1024;i++) desc->conn[i]='\0';
  if(desc->referer!=NULL)    for(i=0;i<1024;i++) desc->referer[i]='\0';
  if(desc->pragma!=NULL)     for(i=0;i<1024;i++) desc->pragma[i]='\0';
  if(desc->contType!=NULL)   for(i=0;i<1024;i++) desc->contType[i]='\0';
  if(desc->contLength!=NULL) for(i=0;i<1024;i++) desc->contLength[i]='\0';
  if(desc->content!=NULL)    for(i=0;i<1024;i++) desc->content[i]='\0';
}


/*
 * copia una struct req_descriptor in un'altra
 */
req_descriptor * cpy_req_descriptor(req_descriptor *desc)
{
  req_descriptor *ritorno;
  if( (ritorno=((req_descriptor *)malloc(sizeof(req_descriptor))))==NULL )
    {
      fprintf(usr_cnsl,"Not enought memory!!!\n");
      exit(1);
    }
  //else init_req_descriptor(ritorno);

  if((ritorno->action=(char *)malloc(10))==NULL){fprintf(usr_cnsl,"Not enough memory!\n");exit(1);}
  if(desc->action!=NULL) strcpy(ritorno->action,desc->action);
  else ritorno->action=NULL;

  if((ritorno->what=(char *)malloc(1024))==NULL){fprintf(usr_cnsl,"Not enough memory!\n");exit(1);}
  if(desc->what!=NULL) strcpy(ritorno->what,desc->what);
  else ritorno->what=NULL;

  if((ritorno->host=(char *)malloc(1024))==NULL){fprintf(usr_cnsl,"Not enough memory!\n");exit(1);}
  if(desc->host!=NULL) strcpy(ritorno->host,desc->host);
  else ritorno->host=NULL;

  if((ritorno->agent=(char *)malloc(1024))==NULL){fprintf(usr_cnsl,"Not enough memory!\n");exit(1);}
  if(desc->agent!=NULL) strcpy(ritorno->agent,desc->agent);
  else ritorno->agent=NULL;

  if((ritorno->accept=(char *)malloc(1024))==NULL){fprintf(usr_cnsl,"Not enough memory!\n");exit(1);}
  if(desc->accept!=NULL) strcpy(ritorno->accept,desc->accept);
  else ritorno->accept=NULL;

  if((ritorno->lang=(char *)malloc(1024))==NULL){fprintf(usr_cnsl,"Not enough memory!\n");exit(1);}
  if(desc->lang!=NULL) strcpy(ritorno->lang,desc->lang);
  else ritorno->lang=NULL;

  if((ritorno->enc=(char *)malloc(1024))==NULL){fprintf(usr_cnsl,"Not enough memory!\n");exit(1);}
  if(desc->enc!=NULL) strcpy(ritorno->enc,desc->enc);
  else ritorno->enc=NULL;

  if((ritorno->charset=(char *)malloc(1024))==NULL){fprintf(usr_cnsl,"Not enough memory!\n");exit(1);}
  if(desc->charset!=NULL) strcpy(ritorno->charset,desc->charset);
  else ritorno->charset=NULL;

  if((ritorno->keep=(char *)malloc(1024))==NULL){fprintf(usr_cnsl,"Not enough memory!\n");exit(1);}
  if(desc->keep!=NULL) strcpy(ritorno->keep,desc->keep);
  else ritorno->keep=NULL;

  if((ritorno->conn=(char *)malloc(1024))==NULL){fprintf(usr_cnsl,"Not enough memory!\n");exit(1);}
  if(desc->conn!=NULL) strcpy(ritorno->conn,desc->conn);
  else ritorno->conn=NULL;

  if((ritorno->referer=(char *)malloc(1024))==NULL){fprintf(usr_cnsl,"Not enough memory!\n");exit(1);}
  if(desc->referer!=NULL) strcpy(ritorno->referer,desc->referer);
  else ritorno->referer=NULL;

  if((ritorno->pragma=(char *)malloc(1024))==NULL){fprintf(usr_cnsl,"Not enough memory!\n");exit(1);}
  if(desc->pragma!=NULL) strcpy(ritorno->pragma,desc->pragma);
  else ritorno->pragma=NULL;

  if((ritorno->contType=(char *)malloc(1024))==NULL){fprintf(usr_cnsl,"Not enough memory!\n");exit(1);}
  if(desc->contType!=NULL) strcpy(ritorno->contType,desc->contType);
  else ritorno->contType=NULL;

  if((ritorno->contLength=(char *)malloc(1024))==NULL){fprintf(usr_cnsl,"Not enough memory!\n");exit(1);}
  if(desc->contLength!=NULL) strcpy(ritorno->contLength,desc->contLength);
  else ritorno->contLength=NULL;

  if((ritorno->content=(char *)malloc(1024))==NULL){fprintf(usr_cnsl,"Not enough memory!\n");exit(1);}
  if(desc->content!=NULL) strcpy(ritorno->content,desc->content);
  else ritorno->content=NULL;

  return ritorno;
}


/*
 * cancella una struct req_descriptor
 */
void rem_req_descriptor(req_descriptor *desc)
{
  int i;
  if(PDEBUG) printf("entro in rem_req_descriptor()\n");
  if((desc->action)!=NULL)     
    {for(i=0;i<10;i++) desc->action[i]='\0';free(desc->action);desc->action=NULL;} 
  if((desc->what)!=NULL)       
    {for(i=0;i<1024;i++) desc->what[i]='\0';free(desc->what);desc->what=NULL;}
  if((desc->host)!=NULL)       
    {for(i=0;i<1024;i++) desc->host[i]='\0';free(desc->host);desc->host=NULL;}
  if((desc->agent)!=NULL)      
    {for(i=0;i<1024;i++) desc->agent[i]='\0';free(desc->agent);desc->agent=NULL;}
  if((desc->accept)!=NULL)     
    {for(i=0;i<1024;i++) desc->accept[i]='\0';free(desc->accept);desc->accept=NULL;}
  if((desc->lang)!=NULL)       
    {for(i=0;i<1024;i++) desc->lang[i]='\0';free(desc->lang);desc->lang=NULL;}
  if((desc->enc)!=NULL)        
    {for(i=0;i<1024;i++) desc->enc[i]='\0';free(desc->enc);desc->enc=NULL;}
  if((desc->charset)!=NULL)    
    {for(i=0;i<1024;i++) desc->charset[i]='\0';free(desc->charset);desc->charset=NULL;}
  if((desc->keep)!=NULL)       
    {for(i=0;i<1024;i++) desc->keep[i]='\0';free(desc->keep);desc->keep=NULL;}
  if((desc->conn)!=NULL)       
    {for(i=0;i<1024;i++) desc->conn[i]='\0';free(desc->conn);desc->conn=NULL;}
  if((desc->referer)!=NULL)    
    {for(i=0;i<1024;i++) desc->referer[i]='\0';free(desc->referer);desc->referer=NULL;}
  if((desc->pragma)!=NULL)     
    {for(i=0;i<1024;i++) desc->pragma[i]='\0';free(desc->pragma);desc->pragma=NULL;}
  if((desc->contType)!=NULL)   
    {for(i=0;i<1024;i++) desc->contType[i]='\0';free(desc->contType);desc->contType=NULL;}
  if((desc->contLength)!=NULL) 
    {for(i=0;i<1024;i++) desc->contLength[i]='\0';free(desc->contLength);desc->contLength=NULL;}
  if((desc->content)!=NULL)    
    {for(i=0;i<1024;i++) desc->content[i]='\0';free(desc->content);desc->content=NULL;}
  if(PDEBUG) printf("campi eliminati....\n");
  if(desc!=NULL) {/*free(desc);*/desc=NULL;}
  if(PDEBUG) printf("esco da rem_req_descriptor()\n");
}


/*
 * stampa una struct req_descriptor in una string
 */
char* print_req_descriptor(req_descriptor *desc)
{
  char *ritorno;
  if((ritorno=(char *)malloc(1024*15))==NULL)
    {
      printf("Not enough memory!\n");
      exit(1);
    }

  sprintf(ritorno,"action: |%s|\nwhat: |%s|\nhost: |%s|\nagent: |%s|\naccept: |%s|\nlang: |%s|\nenc: |%s|\ncharset: |%s|\nkeep: |%s|\nconn: |%s|\nrefer: |%s|\npragma: |%s|\ncontType: |%s|\ncontLength: |%s|\ncontent: |%s|\n",
	  desc->action,
	  desc->what,
	  desc->host,
	  desc->agent,
	  desc->accept,
	  desc->lang,
	  desc->enc,
	  desc->charset,
	  desc->keep,
	  desc->conn,
	  desc->referer,
	  desc->pragma,
	  desc->contType,
	  desc->contLength,
	  desc->content);
  return ritorno;
}


/*
 * crea una nuova struct req_descriptor dalla stringa passata
 * alloca memoria, la inizializza e riempie i campi
 */
req_descriptor* parse_request(char *req)
{
  req_descriptor* ritorno;
  char reqcpy[BUFSIZE];
  int i;
  
  if( (ritorno=((req_descriptor *)malloc(sizeof(req_descriptor))))==NULL )
    {
      fprintf(usr_cnsl,"Not enought memory!!!\n");
      exit(1);
    }
  //else init_req_descriptor(ritorno);

  if(PDEBUG) printf("Entro in parse_request\n");

  for(i=0;i<BUFSIZE;i++) reqcpy[i]='\0';
  strncpy(reqcpy,req,strlen(req));
  ritorno->action=get_op(reqcpy);
  for(i=0;i<BUFSIZE;i++) reqcpy[i]='\0';
  strncpy(reqcpy,req,strlen(req));
  if(ritorno->action!=NULL)
    {
      if(!strcmp(ritorno->action,"CHA"))  ritorno->what=nomefile(reqcpy,1) ;
      else ritorno->what=nomefile(reqcpy,0);
    } 
  else ritorno->what=NULL;
  for(i=0;i<BUFSIZE;i++) reqcpy[i]='\0';
  strncpy(reqcpy,req,strlen(req));
  ritorno->host=gimme_line(reqcpy,"Host: ");
  for(i=0;i<BUFSIZE;i++) reqcpy[i]='\0';
  strncpy(reqcpy,req,strlen(req));
  ritorno->agent=gimme_line(reqcpy,"User-Agent: "); 
  for(i=0;i<BUFSIZE;i++) reqcpy[i]='\0';
  strncpy(reqcpy,req,strlen(req));
  ritorno->accept=gimme_line(reqcpy,"Accept: ");
  for(i=0;i<BUFSIZE;i++) reqcpy[i]='\0';
  strncpy(reqcpy,req,strlen(req));
  ritorno->lang=gimme_line(reqcpy,"Accept-Language: ");
  for(i=0;i<BUFSIZE;i++) reqcpy[i]='\0';
  strncpy(reqcpy,req,strlen(req));
  ritorno->enc=gimme_line(reqcpy,"Accept-Encoding: ");
  for(i=0;i<BUFSIZE;i++) reqcpy[i]='\0';
  strncpy(reqcpy,req,strlen(req));
  ritorno->charset=gimme_line(reqcpy,"Accept-Charset: ");
  for(i=0;i<BUFSIZE;i++) reqcpy[i]='\0';
  strncpy(reqcpy,req,strlen(req));
  ritorno->keep=gimme_line(reqcpy,"Keep-Alive: ");
  for(i=0;i<BUFSIZE;i++) reqcpy[i]='\0';
  strncpy(reqcpy,req,strlen(req));
  ritorno->conn=gimme_line(reqcpy,"Connection: ");
  for(i=0;i<BUFSIZE;i++) reqcpy[i]='\0';
  strncpy(reqcpy,req,strlen(req));
  ritorno->referer=gimme_line(reqcpy,"Referer: ");
  for(i=0;i<BUFSIZE;i++) reqcpy[i]='\0';
  strncpy(reqcpy,req,strlen(req));
  ritorno->pragma=gimme_line(reqcpy,"Pragma: ");
  for(i=0;i<BUFSIZE;i++) reqcpy[i]='\0';
  strncpy(reqcpy,req,strlen(req));
  ritorno->contType=gimme_line(reqcpy,"Content-Type: ");
  for(i=0;i<BUFSIZE;i++) reqcpy[i]='\0';
  strncpy(reqcpy,req,strlen(req));
  ritorno->contLength=gimme_line(reqcpy,"Content-Length: ");
  for(i=0;i<BUFSIZE;i++) reqcpy[i]='\0';
  strncpy(reqcpy,req,strlen(req));
  ritorno->content=gimme_content(reqcpy);
  for(i=0;i<BUFSIZE;i++) reqcpy[i]='\0';
  return ritorno;
}


/*
 * restituisce la riga della stringa buf che inizia per *line (senza *line)
 */
char* gimme_line(char *buf,char *line)
{
  char *start,*end,*ritorno;
  int i;
  if(strstr(buf,line)==NULL) return NULL;

  start=(strstr(buf,line)+strlen(line));
  end=start;
  while((*end!='\n' && *end!='\r') &&((end-start)<1024 )) end++;
  *end='\0';

  if((ritorno=(char *)malloc(1024))==NULL)
    {
      fprintf(usr_cnsl,"Not enough memory!\n");
      exit(1);
    }
  for(i=0;i<1024;i++) ritorno[i]='\0';
  strncpy(ritorno,start,1024); ritorno[1023]='\0';
  return ritorno;
}


/*
 * restituisce la riga della stringa buf che contiene informazioni (dopo il \n\n)
 */
char* gimme_content(char *buf)
{
  char *start,*ritorno; //,*end;
  int i;

  start=strstr(buf,"Content-Length:");
  if(start==NULL) return NULL;
  else while(*start!='\n') start++;               //arrivo sopra il primo '\n'
  if(*(start+1)=='\r') start++;                   //niente niente mi hanno mandato '\r\n' ?
  if(*(++start)=='\n') start++;                   //se trovo anche il secondo vado avanti

  if((ritorno=(char *)malloc(1024))==NULL)
    {
      fprintf(usr_cnsl,"Not enough memory!\n");
      exit(1);
    }

  for(i=0;i<1024;i++) ritorno[i]='\0';
  strncpy(ritorno,start,1024);ritorno[1023]='\0'; //ora posso copiare;
  if(ritorno[0]=='\0') 
    { 
      if(PDEBUG) printf("get_content - elimino ritorno..\n");
      free(ritorno);
      return NULL;
    }             //se non ho copiato niente....
  return ritorno;
}


/*
 * restituisce l'operazione richiesta
 */
char* get_op(char *buf)
{
  char* op;
  int i,finded_flag;
  if((op=(char *)malloc(10))==NULL)
    {
      fprintf(usr_cnsl,"Not enough memory!\n");
      exit(1);
    }
  else for(i=0;i<10;i++) op[i]='\0';

  if(buf!=NULL && strlen(buf)>=3)
    { 
      i=0;
      while(buf[i]!=' ' && ((buf[i]!='\0' && buf[i]!='\n') && buf[i]!='\r'))
	{
	  op[i]=buf[i];
	  i++;
	}
      op[i]='\0';
      
      i=0;finded_flag=0;
      while(ACCEPTED_METHODS[i]!=NULL)
	{
	  if(!strcmp(op,ACCEPTED_METHODS[i])) finded_flag=1;
	  i++;
	}
      if(!finded_flag) op=NULL;
    }
  else op=NULL;
  return op;
}


/** Convert a two-char hex string into the char it represents. **/
char x2c(char *what) {
   register char digit;

   digit = (what[0] >= 'A' ? ((what[0] & 0xdf) - 'A')+10 : (what[0] - '0'));
   digit *= 16;
   digit += (what[1] >= 'A' ? ((what[1] & 0xdf) - 'A')+10 : (what[1] - '0'));
   return(digit);
}

/** Reduce any %xx escape sequences to the characters they represent. **/
void unescape_url(char *url) {
    register int i,j;

    for(i=0,j=0; url[j]; ++i,++j) {
        if((url[i] = url[j]) == '%') {
            url[i] = x2c(&url[j+1]) ;
            j+= 2 ;
        }
    }
    url[i] = '\0' ;
}


/*
 * restituisce il nome del file richiesto (tenendo conto della variabile rootdir)
 * applica eventuali conversioni per caratteri speciali
 */
char* nomefile(char *buf,const int msg)
{
  char *cp, *cp2,*ritorno;
  int i;
  //  struct stat st;

  cp=buf+(strlen(get_op(buf))+2); //buf+5;
  cp2=strstr(cp," HTTP"); if(cp2!=NULL) *cp2='\0';
  cp2=strstr(cp,"\r\n"); if(cp2==cp) return NULL;
  while(cp[0]=='.' || cp[0]=='/') 
    for(i=1;cp[i]!='\0';i++)
      { 
	cp[i-1]=cp[i];
	if(cp[i+1]=='\0') cp[i]='\0';
      }
  
  if((ritorno=(char *)malloc(1024))==NULL)
    {
      fprintf(usr_cnsl,"Not enough memory!\n");
      exit(1);
    }
  else for(i=0;i<1024;i++) ritorno[i]='\0';

  if(rootdir!=NULL && !msg)
    { 
      strcpy(ritorno,rootdir);
      if(ritorno[strlen(ritorno)-1]!='/') strcat(ritorno,"/");
    }

  
  unescape_url(cp);
  strcat(ritorno,cp);
  /*if(ritorno[strlen(ritorno)-1]!='/')  //non so bene se e' un file o una dir
    {
      if(stat(ritorno,&st)==-1)
	{
	  return ritorno;             //non riesco ad aprirlo.. l'errore verra' segnalato dopo..
	}
      else if(S_ISDIR(st.st_mode))    //ora lo so.....
	{
	  strcat(ritorno,"/");
	}
    }*/
  return ritorno;
}


/*
 * controlla se path  interno o no a wsmp3_rootDIR o wsmp3_accepted
 * ritorna 1 ( e' interno ) 0 ( non  interno )
 */
int is_inside(char *path)
{
  struct stat st;
  int i;
  char *cp;
  char pointed[1024];
  char curp[1024];
  char root_dir[1024];
  char superdir[1024];
  strcpy(root_dir,rootdir); if(root_dir[strlen(root_dir)-1]=='/') root_dir[strlen(root_dir)-1]='\0';
  strcpy(curp,path); if(strcmp(curp,"/") && curp[strlen(curp)-1]=='/') curp[strlen(curp)-1]='\0' ;
  strcpy(superdir,curp);
  cp=superdir+(strlen(superdir)-1);
  while(cp>superdir && *(cp-1)!='/') cp--; *cp='\0';

  if(!strcmp(curp,root_dir)) return 1;

  lstat(curp,&st);
  if( (S_ISDIR(st.st_mode) || S_ISREG(st.st_mode)) && (strstr(curp,rootdir)!=curp) )
    {
      i=0;
      while(DIRS[i]!=NULL)
	{
	  if(strstr(curp,DIRS[i])==curp) return 1;
	  i++;
	}
      return 0;
    }
  else if(S_ISLNK(st.st_mode))
    {
      for(i=0;i<1024;i++) pointed[i]='\0';
      readlink(curp,pointed,1024);
      if((strstr(pointed,"..")==pointed) && !strcmp(superdir,root_dir)) return 0;
      if(pointed[0]=='.' && (pointed[1]=='/' || pointed[1]=='\0')) return 1;
      return is_inside(pointed);
    }
  return (1 && is_inside(superdir));
}


/*
 * invia la lista del contenuto di una directory
 */
void send_dir_list(int sock, req_descriptor *reqd)
{
  DIR *d;
  struct dirent *de;
  struct stat st;
  char dirslash[1024];
  char path[1024];
  char row[1024]; 
  char weight[80];
  char *dirname;
  char *spacesbuf;
  int spaces,i;
  int somethingwritten;
  int total=0;
  int html=0;
  char *error1 = "Error listing directory\n";
  char *header =  "HTTP/1.1 200 OK\n"
    "Connection: close\n"
    "Content-Type: text/html\n\n";
  char *start_html = "<html><head><title>ls command output"
    "</title><LINK rel=stylesheet href=\"/data/styles.css\" type=\"text/css\"></head><body>"
    "<table border=\"0\"> ";
  char *end_html = "</table></body></html>";
  char *directory = "<IMG src=\"/data/directory.jpg\" height=16 width=16>";
  char *file = "<IMG src=\"/data/file.jpg\" height=16 width=16>";
  char *nothing_html = "<h3>nothing here!</h3>";
  char *nothing_txt = "nothing here!\n";
  char *errstr;
  somethingwritten=0;

  if(needHeader(reqd)) html=1;

  dirname=reqd->what;

  if(!ls_follow_outside_links && !is_inside(dirname))   //se is_inside ritorna 0 non lo mostro....
    {
      errstr=write_error_msg(reqd,"no such directory");
      programWIDE_totalSent+=send(sock,errstr,strlen(errstr),0);
      if (DEBUG) fprintf(usr_cnsl,"Sent Error:%s\n",errstr);
      if(logflag)
	{
	  time(&tempo);
	  fprintf(logfile,"%s Sent Error:%s\n", mytime(localtime(&tempo)),errstr);
	  fflush(logfile);
	}
      return;
    } 
  else d = opendir(dirname);

  if(!d)
    {
      if(html)
	{
	  programWIDE_totalSent+=send(sock,header,strlen(header),0);
	  programWIDE_totalSent+=send(sock,start_html,strlen(start_html),0);
	  programWIDE_totalSent+=send(sock,"<tr><td>",strlen("<tr><td>"),0);	  
	}
      programWIDE_totalSent+=send(sock,error1,strlen(error1),0);
      if(html)
	{
	  programWIDE_totalSent+=send(sock,"</td></tr>",strlen("</td></tr>"),0);  
	  programWIDE_totalSent+=send(sock,end_html,strlen(end_html),0);
	}
      if (DEBUG) fprintf(usr_cnsl,"Error sending directory list\n");
      if(logflag)
	{
	  time(&tempo);
	  fprintf(logfile,"%s Error sending directory list\n", mytime(localtime(&tempo)));
	  fflush(logfile);
	}
      return;
    }
  
  strcpy(dirslash,dirname);			// add final / if needed
  if(dirslash[strlen(dirslash)-1] != '/')
    strcat(dirslash,"/");
  
  if(html)
    {
      programWIDE_totalSent+=send(sock,header,strlen(header),0);
      programWIDE_totalSent+=send(sock,start_html,strlen(start_html),0);
    }

  while((de = readdir(d)))
    {		// read all dirents
      if(de->d_name[0] == '.')	// doesn't show hidden files
	continue;      
      strcpy(path,dirslash);
      strcat(path,de->d_name);
      if(!ls_follow_outside_links && !is_inside(path)) 
	continue;  //se is_inside ritorna -1 non lo mostro....
      stat(path,&st);

      if((int)st.st_size>=GIGA) 
	sprintf(weight,"%.2lf %s",(double)st.st_size/GIGA,"Gbytes");
      else if((int)st.st_size>=MEGA) 
	sprintf(weight,"%.2lf %s",(double)st.st_size/MEGA,"Mbytes");
      else  if((int)st.st_size>=KILO) 
	sprintf(weight,"%.2lf %s",(double)st.st_size/KILO,"Kbytes");
      else sprintf(weight,"%d %s",(int)st.st_size,"bytes");

      if(html)
	{ 
	  sprintf(row,"<tr>
                         <td>%s</td>
                         <td><a href=\"%s%s\">%s</a></td>
                         <td><DIV class=testo>%s</DIV></td>
                       </tr>\n\r",
		  S_ISDIR(st.st_mode)? directory:file,
		  de->d_name,
		  S_ISDIR(st.st_mode)? "/cmd:ls":"",
		  de->d_name,
		  weight); 
	}
      else 
	{
	  spaces=60-strlen(de->d_name);
	  if(spaces<0) spaces=1;
	  if((spacesbuf=(char *)malloc(spaces))==NULL)
	    {
	      fprintf(usr_cnsl,"Not enough memory!\n");
	      exit(1);
	    }
	  for(i=0;i<spaces-1;i++) spacesbuf[i]=' ';
	  spacesbuf[spaces-1]='\0';
	  sprintf(row,"%s %s%s%s\n",S_ISDIR(st.st_mode) ? "<DIR>" : "     ",de->d_name,spacesbuf,weight);
	  free(spacesbuf);
	}
      somethingwritten=1;
      programWIDE_totalSent+=send(sock,row,strlen(row),0); // send a row (a file)
      total+=(int)st.st_size;
    }
  
  if(!somethingwritten && html)  programWIDE_totalSent+=send(sock,nothing_html,strlen(nothing_html),0);
  if(!somethingwritten && !html) programWIDE_totalSent+=send(sock,nothing_txt,strlen(nothing_txt),0);

  if(somethingwritten && html)
    {
      if(total>=GIGA) 
	sprintf(weight,"%.2lf %s",(double)total/GIGA,"Gbytes");
      else if(total>=MEGA) 
	sprintf(weight,"%.2lf %s",(double)total/MEGA,"Mbytes");
      else  if(total>=KILO) 
	sprintf(weight,"%.2lf %s",(double)total/KILO,"Kbytes");
      else sprintf(weight,"%d %s",total,"bytes");

      sprintf(row,"<tr>
                      <td>&nbsp;</td>
                      <td><DIV class=testo><B>Total:</B></DIV></td>
                      <td><DIV class=testo><B>%s</B></DIV></td>
                   </tr>\n\r",
	      weight);
      programWIDE_totalSent+=send(sock,row,strlen(row),0);
    }

    if(somethingwritten && !html)
    {
      if(total>=GIGA) 
	sprintf(weight,"%.2lf %s",(double)total/GIGA,"Gbytes");
      else if(total>=MEGA) 
	sprintf(weight,"%.2lf %s",(double)total/MEGA,"Mbytes");
      else  if(total>=KILO) 
	sprintf(weight,"%.2lf %s",(double)total/KILO,"Kbytes");
      else sprintf(weight,"%d %s",total,"bytes");

      sprintf(row,"Total: %s\n",weight);
      programWIDE_totalSent+=send(sock,row,strlen(row),0);
    }

  if(html) programWIDE_totalSent+=send(sock,end_html,strlen(end_html),0);
  closedir(d);

  if (DEBUG) fprintf(usr_cnsl,"Directory list sent successfully\n");
  
  if(logflag)
    {
      time(&tempo);
      fprintf(logfile,"%s Directory list sent successfully\n",mytime(localtime(&tempo)));
      fflush(logfile);
    }
}


/*
 * invia un header appropriato se tutto ok, altrimenti non invia header.
 * invia un header solo a (m)ozilla, (o)pera o Wget......
 * read file restituisce : 1 (tutto ok) , 2 (e' finita la connessione) , 0 (errore)
 * se errore imposta n_errno a errno, una chiamata a write_error_msg imposta n_errno a -1
 */
int read_file(req_descriptor *reqd,int *sock)
{
  int i,j,totalBytes,bytesSent,totalSent,size,times;
  int stop;
  FILE *f;
  char *header =  "HTTP/1.1 200 OK\n"
    "Connection: close\n"
    "Content-Type: ";
  char head1[1024];
  char file_jpg_location[1024];
  char directory_jpg_location[1024];
  char styles_css_location[1024];
  struct stat st;
  f=NULL;

  sprintf(file_jpg_location,
	  "%s%sdata/file.jpg",rootdir,(rootdir[strlen(rootdir)-1]!='/') ? "/" : "");
  sprintf(directory_jpg_location,
	  "%s%sdata/directory.jpg",rootdir,(rootdir[strlen(rootdir)-1]!='/') ? "/" : "");
  sprintf(styles_css_location,
	  "%s%sdata/styles.css",rootdir,(rootdir[strlen(rootdir)-1]!='/') ? "/" : "");

  if(PDEBUG) printf("Entrato in read_file()\n");
  if(DEBUG) fprintf(usr_cnsl,"file: |%s|\n",reqd->what);
  if(logflag)
    { 
      time(&tempo);
      fprintf(logfile,"%s file: |%s|\n",mytime(localtime(&tempo)),reqd->what);
    }

  /***************file.jpg , directory.jpg , styles.css sono interni al programma******************/

  if(!strcmp(reqd->what,file_jpg_location))           // /data/file.jpg
    {
      time(&tempo);
      sprintf(head1,"%s%s\nDate: %s\nLast-Modified: %s\nContent-Length: %d\n\n",
	      header,
	      get_filedesc(".jpg"),
	      mytime(localtime(&tempo)),
	      mytime(localtime(&tempo)),
	      file_jpg_bufsize);
      
      if(needHeader(reqd)) 
	{
	  programWIDE_totalSent+=send(*sock,head1,strlen(head1),0);
	  if(DEBUG) fprintf(usr_cnsl,"Sent header:\n%s",head1);
	  if(logflag)
	    { 
	      time(&tempo);
	      fprintf(logfile,"%s Sent header:\n%s",mytime(localtime(&tempo)),head1);
	      fflush(logfile);
	    }
	}
      programWIDE_totalSent+=send(*sock,file_jpg,file_jpg_bufsize,0); 
      
      if(DEBUG) fprintf(usr_cnsl,"%d bytes read from file %s\n",file_jpg_bufsize,reqd->what);
      if(logflag) 
	{
	  time(&tempo);
	  fprintf(logfile,"%s %d bytes read from file %s\n",
		  mytime(localtime(&tempo)),
		  file_jpg_bufsize,
		  reqd->what);
	  fflush(logfile);
	}
      return 1;
    }

  else if(!strcmp(reqd->what,directory_jpg_location))    // /data/directory.jpg
    {
      time(&tempo);
      sprintf(head1,"%s%s\nDate: %s\nLast-Modified: %s\nContent-Length: %d\n\n",
	      header,
	      get_filedesc(".jpg"),
	      mytime(localtime(&tempo)),
	      mytime(localtime(&tempo)),
	      directory_jpg_bufsize);

      if(needHeader(reqd))
	{
	  programWIDE_totalSent+=send(*sock,head1,strlen(head1),0);	  
	  if(DEBUG) fprintf(usr_cnsl,"Sent header:\n%s",head1);
	  if(logflag)
	    { 
	      time(&tempo);
	      fprintf(logfile,"%s Sent header:\n%s",mytime(localtime(&tempo)),head1);
	      fflush(logfile);
	    }
	}

      programWIDE_totalSent+=send(*sock,directory_jpg,directory_jpg_bufsize,0);
      
      if(DEBUG) fprintf(usr_cnsl,"%d bytes read from file %s\n",directory_jpg_bufsize,reqd->what);
      if(logflag) 
	{
	  time(&tempo);
	  fprintf(logfile,"%s %d bytes read from file %s\n",
		  mytime(localtime(&tempo)),
		  directory_jpg_bufsize,
		  reqd->what);
	  fflush(logfile);
	}
      return 1;
    }


  else if(!strcmp(reqd->what,styles_css_location))    // /data/styles.css
    {
      time(&tempo);
      sprintf(head1,"%s%s\nDate: %s\nLast-Modified: %s\nContent-Length: %d\n\n",
	      header,
	      get_filedesc(".css"),
	      mytime(localtime(&tempo)),
	      mytime(localtime(&tempo)),
	      styles_css_bufsize);

      if(needHeader(reqd))
	{
	  programWIDE_totalSent+=send(*sock,head1,strlen(head1),0);	  
	  if(DEBUG) fprintf(usr_cnsl,"Sent header:\n%s",head1);
	  if(logflag)
	    { 
	      time(&tempo);
	      fprintf(logfile,"%s Sent header:\n%s",mytime(localtime(&tempo)),head1);
	      fflush(logfile);
	    }
	}

      programWIDE_totalSent+=send(*sock,styles_css,styles_css_bufsize,0);

      if(DEBUG) fprintf(usr_cnsl,"%d bytes read from file %s\n",styles_css_bufsize,reqd->what);
      if(logflag) 
	{
	  time(&tempo);
	  fprintf(logfile,"%s %d bytes read from file %s\n",
		  mytime(localtime(&tempo)),
		  styles_css_bufsize,
		  reqd->what);
	  fflush(logfile);
	}
      return 1;
    }

  /*********************************per tutti gli altri files**********************************/ 

  //controllo esistenza del file....
  f=fopen(reqd->what,"r");
  if(f==NULL) 
    {
      n_errno=errno;
      if(DEBUG) fprintf(usr_cnsl,"%s: %s\n",reqd->what,sys_errlist[n_errno]);
      if(logflag)
	{ 
	  time(&tempo);
	  fprintf(logfile,"%s %s: %s\n",mytime(localtime(&tempo)),reqd->what,sys_errlist[n_errno]);
	  fflush(logfile);
	}
      return 0; 
    }

  //controllo se posso andarlo a prendere
  if(!ls_follow_outside_links && !is_inside(reqd->what)) 
    {
      n_errno=EACCES;
      if(DEBUG) fprintf(usr_cnsl,"%s: %s\n",reqd->what,sys_errlist[n_errno]);
      if(logflag)
	{ 
	  time(&tempo);
	  fprintf(logfile,"%s %s: %s\n",mytime(localtime(&tempo)),reqd->what,sys_errlist[n_errno]);
	  fflush(logfile);
	}
      return 0;
    }

  //controllo se posso eseguire stat
  time(&tempo);
  if(stat(reqd->what,&st)==-1)
     {
       i=errno;
       if(DEBUG) fprintf(usr_cnsl,"%s: %s\n",reqd->what,sys_errlist[i]);
       if(logflag)
	 { 
	   time(&tempo);
	   fprintf(logfile,"%s %s: %s\n",mytime(localtime(&tempo)),reqd->what,sys_errlist[i]);
	   fflush(logfile);
	 }
       sprintf(head1,"%s%s\nDate: %s\n\n",header,get_filedesc(reqd->what),mytime(localtime(&tempo)));
     }  
   else sprintf(head1,"%s%s\nDate: %s\nLast-Modified: %s\nContent-Length: %d\n\n",
		header,
		get_filedesc(reqd->what),
		mytime(localtime(&tempo)),
		mytime(localtime(&(st.st_mtime))),
		(int)st.st_size);
   
  //controllo se devo inviare un header
  if(needHeader(reqd))
    {
      programWIDE_totalSent+=send(*sock,head1,strlen(head1),0);
      if(DEBUG) fprintf(usr_cnsl,"Sent header:\n%s",head1);
      if(logflag)
	{ 
	  time(&tempo);
	  fprintf(logfile,"%s Sent header:\n%s",mytime(localtime(&tempo)),head1);
	  fflush(logfile);
	}
    }
  
  //tutto ok, inizio a trasferire
  for(j=0;j<BUFSIZE;j++)ret_buf[j]='\0';
  totalBytes=0;
  times=0;
  stop=0;
  while((!stop)&&(!feof(f)))
    { 
      times++;
      i=fread(ret_buf,1,BUFSIZE,f);
      if(DEBUG) fprintf(usr_cnsl,"[%d]in read_file(PID:%d),while(!feof(f))=>i:%d\n",times,getpid(),i);
      if(logflag)
	{ 
	  time(&tempo);
	  fprintf(logfile,"%s [%d]in read_file(PID:%d),while(!feof(f))=>i:%d\n",mytime(localtime(&tempo)),times,getpid(),i);	  
	  if(times%10==0) fflush(logfile);
	}
      
      if(i==0) 
	{
	  //c'e' un errore in lettura?
	  if(ferror(f))
	    {
	      fclose(f);  
	      n_errno=errno;
	      if(DEBUG) fprintf(usr_cnsl,"%d bytes read from file %s,in %d times\n",
				totalBytes,reqd->what,times);
	      if(logflag) 
		{
		  time(&tempo);
		  fprintf(logfile,"%s %d bytes read from file %s,in %d times\n",
			  mytime(localtime(&tempo)),
			  totalBytes,
			  reqd->what,
			  times);
		  fflush(logfile);
		}
	      programWIDE_totalSent+=totalBytes;
	      return 0;
	    }
	  //o ho finito il file?
	  stop=1;
	  break;
	}

      //ho letto un blocco, lo invio......
      size=i;
      totalSent=0;
      do
	{
	  bytesSent=send(*sock,ret_buf+totalSent,i-=totalSent,0);
	  if(bytesSent==-1)
	    {
	      if(DEBUG) fprintf(usr_cnsl,"%d bytes read from file %s,in %d times\n",
				totalBytes,reqd->what,times);
	      if(logflag) 
		{
		  time(&tempo);
		  fprintf(logfile,"%s %d bytes read from file %s,in %d times\n",
			  mytime(localtime(&tempo)),
			  totalBytes,
			  reqd->what,
			  times);
		  fflush(logfile);
		}
	      programWIDE_totalSent+=totalBytes; 
	      return 2;
	    }
	  totalSent+=bytesSent;
	}while(totalSent<size);
      totalBytes+=totalSent;
    }

  //finito di leggere il file, ricapitoliamo....
  if(DEBUG) fprintf(usr_cnsl,"%d bytes read from file %s,in %d times\n",totalBytes,reqd->what,times);
  if(logflag) 
    {
      time(&tempo);
      fprintf(logfile,"%s %d bytes read from file %s,in %d times\n",
	      mytime(localtime(&tempo)),
	      totalBytes,
	      reqd->what,
	      times);
      fflush(logfile);
    }
  fclose(f);

  programWIDE_totalSent+=totalBytes;

  return 1;
}


/*
 * invia un file leggendo da uno stream gia' aperto !USATO SOLO PER CGI-BIN!
 */
int dread_file(FILE *filedes,char *filetype,int *sock)
{
  int i,j,totalBytes,bytesSent,totalSent,size,times;
  int stop;
  char *header =  "HTTP/1.1 200 OK\n"
    "Connection: close\n"
    "Content-Type: ";
  char head1[1024];
  struct stat st;

  time(&tempo);
  fstat(fileno(filedes),&st);
  sprintf(head1,"%s%s\nDate: %s\nLast-Modified: %s\nContent-Length: %d\n\n",
	  header,
	  get_filedesc(filetype),
	  mytime(localtime(&tempo)),
	  mytime(localtime(&(st.st_mtime))),
	  (int)st.st_size);
  programWIDE_totalSent+=send(*sock,head1,strlen(head1),0);
  if(DEBUG) fprintf(usr_cnsl,"%s Sent header:\n%s",mytime(localtime(&tempo)),head1);
  if(logflag)
    { 
      time(&tempo);
      fprintf(logfile,"%s Sent header:\n%s",mytime(localtime(&tempo)),head1);
      fflush(logfile);
    }   
  for(j=0;j<BUFSIZE;j++)ret_buf[j]='\0';
  totalBytes=0;
  times=0;
  stop=0;
  lseek(fileno(filedes),0,SEEK_SET);
  while((!stop)&&(!feof(filedes)))
    { 
      times++;
      i=fread(ret_buf,1,BUFSIZE,filedes);
      if(DEBUG) fprintf(usr_cnsl,"[%d]in dread_file(PID:%d),while(!feof(filedes))=>i:%d\n",
			times,getpid(),i);	  
      if(logflag)
	{ 
	  time(&tempo);
	  fprintf(logfile,"%s [%d]in dread_file(PID:%d),while(!feof(filedes))=>i:%d\n",
		  mytime(localtime(&tempo)),times,getpid(),i);	  
	  if(times%10==0) fflush(logfile);
	}

      if(i==0)
	{
	  if(ferror(filedes))
	    {
	      n_errno=errno;
	      if(DEBUG) fprintf(usr_cnsl,"%d bytes read from filedes,in %d times\n",totalBytes,times);
	      if(logflag) 
		{
		  time(&tempo);
		  fprintf(logfile,"%s %d bytes read from filedes,in %d times\n",
			  mytime(localtime(&tempo)),
			  totalBytes,
			  times);
		  fflush(logfile);
		}
	      programWIDE_totalSent+=totalBytes;
	      return 0;
	    }
	  stop=1;
	  break;
	}
      size=i;
      totalSent=0;
      do
	{
	  bytesSent=send(*sock,ret_buf+totalSent,i-=totalSent,0);
	  if(bytesSent==-1)
	    {
	      if(DEBUG) fprintf(usr_cnsl,"%d bytes read from filedes,in %d times\n",totalBytes,times); 
	      if(logflag) 
		{
		  time(&tempo);
		  fprintf(logfile,"%s %d bytes read from filedes,in %d times\n",
			  mytime(localtime(&tempo)),
			  totalBytes,
			  times);
		  fflush(logfile);
		}
	      programWIDE_totalSent+=totalBytes; 
	      return 2;
	    }
	  totalSent+=bytesSent;
	}while(totalSent<size);
      totalBytes+=totalSent;
    }
  if(DEBUG) fprintf(usr_cnsl,"%d bytes read from filedes,in %d times\n",totalBytes,times);
  if(logflag) 
    {
      time(&tempo);
      fprintf(logfile,"%s %d bytes read from filedes,in %d times\n",
	      mytime(localtime(&tempo)),
	      totalBytes,
	      times);
      fflush(logfile);
    }
  programWIDE_totalSent+=totalBytes;
  return 1;
}


/*
 * invia in continuazione i files mp3 in una directory
 */
void read_mp3_dir(req_descriptor *reqd,int *sock)
{
  DIR *d;
  struct dirent *de;
  req_descriptor *reqd_cpy;

  programWIDE_totalSent+=send(*sock,"ICY 200 OK",strlen("ICY 200 OK"),0);
  programWIDE_totalSent+=send(*sock,"icy-metaint:?????",strlen("icy-metaint:?????"),0);
  while(1)
    {
      d = opendir(reqd->what);
      while((de = readdir(d)))
	{		// read all dirents
	  if(de->d_name[0] == '.')	// doesn't show hidden files
	    continue;
	  if(!ISMP3(de->d_name)) continue;
	  
	  reqd_cpy=cpy_req_descriptor(reqd);

	  strcat(reqd_cpy->what,de->d_name);
	  
	  if(DEBUG) fprintf(usr_cnsl,"Sending: %s\n",reqd_cpy->what);
	  if(logflag)
	    { 
	      time(&tempo);
	      fprintf(logfile,"%s Sending: %s\n", mytime(localtime(&tempo)),reqd_cpy->what);	  
	      fflush(logfile);
	    }
	  if(read_file(reqd_cpy,sock)==2) return;
	  
	}
    }
}


/*
 * invia un file mp3
 */
void read_mp3_file(req_descriptor *reqd,int *sock)
{
  struct stat st;
  char metaint[1024];
  char *err="";
 
  stat(reqd->what,&st);
  sprintf(metaint,"icy-metaint:%d",(int)st.st_size);

  if(ISMP3(reqd->what))
    {
      programWIDE_totalSent+=send(*sock,"ICY 200 OK",strlen("ICY 200 OK"),0);
      programWIDE_totalSent+=send(*sock,metaint,strlen(metaint),0);
      if(!read_file(reqd,sock)) 
	send(*sock,err=write_error_msg(reqd,(char*)sys_errlist[n_errno]),strlen(err),0); 
    }
}

/*
 * invia un file html leggendo da un file descriptor gi aperto !USATO SOLO PER CGI-BIN!
 */
void dread_html_file(FILE *filedes,int *sock)
{
    char *err;
    if(!dread_file(filedes,".htm",sock))
      {
	err=write_error_msg(NULL,(char *)sys_errlist[n_errno]);
	send(*sock,err,strlen(err),0); 
	
	if(DEBUG) fprintf(usr_cnsl,"Sent error:\n%s\n",err);
	if(logflag)
	  { 
	       time(&tempo);
	       fprintf(logfile,"%s Sent error:\n%s\n",mytime(localtime(&tempo)),err);
	       fflush(logfile);
	  }
      }
}

/*
 * invia un file HTML , 
 * se il file <nomefile>.htm non viene trovato prova con il file <nomefile>.html 
 * prima di inviare un errore e viceversa
 */
void read_html_file(req_descriptor *reqd,int *sock)
{
   char *err;

   if(ISHTM(reqd->what) && !read_file(reqd,sock))
     { 
       strcat(reqd->what,"l"); 
       if(!read_file(reqd,sock))
	 {
	   err=write_error_msg(reqd,(char *)sys_errlist[n_errno]);
	   send(*sock,err,strlen(err),0); 
	   
	   if(DEBUG) fprintf(usr_cnsl,"Sent error:\n%s\n",err);
	   if(logflag)
	     { 
	       time(&tempo);
		fprintf(logfile,"%s Sent error:\n%s\n",mytime(localtime(&tempo)),err);
		fflush(logfile);
	     }
	 }
       return;
     }
   else if(strstr(reqd->what,".html") && !read_file(reqd,sock))
     {
       reqd->what[strlen(reqd->what)-1]='\0';
	if(!read_file(reqd,sock))
	  {
	    err=write_error_msg(reqd,(char *)sys_errlist[n_errno]);
	    send(*sock,err,strlen(err),0);

	    if(DEBUG) fprintf(usr_cnsl,"Sent error:\n%s\n",err);
	    if(logflag)
	      { 
		time(&tempo);
		fprintf(logfile,"%s Sent error:\n%s\n",mytime(localtime(&tempo)),err);
		fflush(logfile);
	      }
	  } 
     }
}


/*
 * invia un qualsiasi file
 */
void read_any_file(req_descriptor *reqd,int *sock)
{
  char *err;
  
  if(!read_file(reqd,sock))
    {
      err=write_error_msg(reqd,(char *)sys_errlist[n_errno]);
      send(*sock,err,strlen(err),0);
      
      if(DEBUG) fprintf(usr_cnsl,"Sent error:\n%s\n",err);
      if(logflag)
	   { 
	     time(&tempo);
	     fprintf(logfile,"%s Sent error:\n%s\n",mytime(localtime(&tempo)),err);
	     fflush(logfile);
	   }
    }
}




/*
 * aggiunta variabile rootdir per la directory in cui sono i file da inviare e la directory data/
 * ora l'eseguibile pu stare in una delle directory *bin/
 *
 * variabili di ambiente: 
 *  wsmp3_rootDIR ==> rootdir
 *  wsmp3_accepted ==> directory che possono essere linkate nella rootdir (per CGI-BIN)
 */
int main(int argc, char *argv[],char *envp[])
{
  int i,j,chati;
  char recvBuffer[BUFSIZE];
  char buf[BUFSIZE],*listadiraccepted;
  int sock,dupsock,tmp_porta,tmp_forkon;
  int serverSocket;
  struct sockaddr_in serverAddr;
  struct sockaddr_in clientAddr;
  int clientAddrSize;
  struct hostent* entity;
  struct sigaction sa_dontcare;
  int childPID;
  char *str,*cp,*cp2,*errstr,arg[80],*arg2[3],*inizio,*fine,**ora;
  int error;
  char chatbuf[1024];
  char filename[100];
  time_t start_tempo;
  FILE *tf;
  req_descriptor *conn_req;
  int fnbf=0; //flag per bloccare la trasmissione di file troppo grandi (FLAG NO BIG FILES)

  programWIDE_totalReceived=0;
  programWIDE_totalSent=0;
  usr_cnsl=fopen("/dev/tty","a");

  /**************************** AMBIENTE DA FILE RC *********************************/

  sprintf(recvBuffer,"%s/.wsmp3rc",getenv("HOME"));
  tf=fopen(recvBuffer,"r");
  if(tf==NULL) tf=fopen("/etc/wsmp3rc","r");
  if(tf==NULL) 
    {
      sprintf(recvBuffer,"%s/.wsmp3rc",getenv("PWD"));
      tf=fopen(recvBuffer,"r");
    }
  if(tf!=NULL)
    {
      for(i=0;i<BUFSIZE;i++) buf[i]=recvBuffer[i]='\0';
      while(!feof(tf))
	{
	  i=fread(recvBuffer,BUFSIZE,1,tf);
	}
      strcpy(buf,recvBuffer);
      setenv("wsmp3_rootDIR",gimme_line(recvBuffer,"wsmp3_rootDIR="),1);
      strcpy(recvBuffer,buf);
      setenv("wsmp3_accepted",gimme_line(recvBuffer,"wsmp3_accepted="),1);
      strcpy(recvBuffer,buf);
      if(!strcmp(gimme_line(recvBuffer,"cmdls-follows="),"yes")) ls_follow_outside_links=1;
  
      fclose(tf);
      for(i=0;i<BUFSIZE;i++) buf[i]=recvBuffer[i]='\0'; 
    }
  
  if(getenv("wsmp3_accepted")==NULL)
    {
      setenv("wsmp3_accepted",getenv("PWD"),1);
    }
  
  rootdir=getenv("wsmp3_rootDIR");
  if(rootdir==NULL)
    { 
      rootdir=getenv("PWD");
    }
  setenv("wsmp3_rootDIR",rootdir,1);
   

  //Riempio l'array delle directory accepted.....
  if(getenv("wsmp3_accepted")!=NULL) 
    {
      listadiraccepted=(char *)malloc(BUFSIZE);
      for(i=0;i<BUFSIZE;i++) listadiraccepted[i]='\0';
      strncpy(listadiraccepted,getenv("wsmp3_accepted"),strlen(getenv("wsmp3_accepted")));
      ora=DIRS;
      inizio=listadiraccepted;
      while(*inizio!='\0')
	{
	  fine=inizio;
	  while(*fine!=':'){if(*fine=='\0')break; fine++;}
	  if(fine[0] == ':') *fine='\0';if(abs(fine-inizio)>1 && *(fine-1)=='/') *(fine-1)='\0';
	  *ora=(char *)malloc(1024);
	  strcpy(*ora,inizio);
	  ora++;
	  inizio=fine+1;
	  if(*inizio=='\0')
	    break;
	}
      *ora=NULL;
      free(listadiraccepted);
      inizio=NULL;
      fine=NULL;
    }

  /*********************************************LINEA DI COMANDO**************************/

  error=0;
  for(j=1;j<argc;j++)
    {
      if(!strcmp(argv[j],"-log"))
	{ 
	  logflag=1;
	  sprintf(recvBuffer,"%s",getenv("PWD"));                       //controllo che la dir corrente
	  if(strstr(recvBuffer,getenv("HOME"))!=recvBuffer)             //sia sotto-dir della mia home
	    sprintf(recvBuffer,"%s/wsmp3-logfile.log",getenv("HOME"));  //se si scrivo nella dir
	  else sprintf(recvBuffer,"%s/wsmp3-logfile.log",getenv("PWD"));//se no scrivo nella mia home
	  logfile=fopen(recvBuffer,"a+");
	  if(logfile==NULL) logflag=0;
	}
      else if(!strcmp(argv[j],"-debug"))
	{
	  if(!CHATMODE) DEBUG=1;
	}
      else if(strstr(argv[j],"-port:"))
      {
	str=strstr(argv[j],"-port:");
	str=str+6;
	tmp_porta=0;
	while(*str!='\0')
	  {
	    tmp_porta=tmp_porta*10+(int)(str[0]-'0');
	    str++;
	  }
	if(tmp_porta<=1024) tmp_porta=8000;
	if(DEBUG) fprintf(usr_cnsl,"MYPORT:%d\n\n",tmp_porta);
	MYPORT=tmp_porta;
      }
      else if(strstr(argv[j],"-forkon:"))
      {
	if(!CHATMODE)
	  {
	    str=strstr(argv[j],"-forkon:");
	    str=str+8;
	    tmp_forkon=0;
	    while(*str!='\0')
	      {
		tmp_forkon=tmp_forkon*10+(int)(str[0]-'0');
		str++;
	      }
	    if(DEBUG) fprintf(usr_cnsl,"FORKON:%d\n\n",tmp_forkon);
	    FORKON=tmp_forkon;
	  }
      }
      else if(!strcmp(argv[j],"--happymode"))
      {
	HAPPYMODE=1;
      }
      else if(!strcmp(argv[j],"--cmdls-follows"))
      {
	ls_follow_outside_links=1;
      }
      else if(!strcmp(argv[j],"-chat"))
      {
	CHATMODE=1;
	FORKON=0;
	DEBUG=0;
      }
      else if(!strcmp(argv[j],"--help")||!strcmp(argv[j],"-h"))
	{
	  printf("%s (%s) %s\n",argv[0],VERSION,AUTHOR);
	  printf("Usage: %s [OPTIONS]\n",argv[0]);
	  printf("OPTIONS are:\n\n");
	  printf("-log\t\t\tEnables log mode\n");
	  printf("-debug\t\t\tEnables debug mode\n");
	  printf("-port:<PORT_NUMBER>\tSet the port users will be connecting to. default is 8000\n");
	  printf("-forkon:<BYTES>\t\tSet the max dimension for the files on which the program don't need to fork (set 0 to fork always). default is 8192\n");
	  printf("-chat\t\t\tEnables chat mode(will fork always and debugging is disabled)\n");
	  printf("--happymode\t\tEnables an \"Happy Mode\"\n");
	  printf("--cmdls-follows\t\tLet cmd:ls to show link pointing outside of wsmp3_rootdir or wsmp3_accepted\n");	  
	  printf("-h,--help\t\tThis help screen.\n\n");
	  exit(0);
	}
      else
	{
	  fprintf(usr_cnsl,"Unrecognized option!! %s\n",argv[j]);
	  error=1;
	}
    }
  
  if(error!=0)
    { 
      fprintf(usr_cnsl,"Exit()\n");
      exit(0);
    }


  /****************************ROOT MODE********************************/

  if(getuid()==0)
    { 
      fprintf(usr_cnsl,"\n\n\t\t*********************************************************\n\n");
      fprintf(usr_cnsl,"\t\t\tYOU ARE RUNNING THIS PROGRAM AS ROOT!!!!\n");
      fprintf(usr_cnsl,"\t\t\tthat's not a good idea man...\n");
      fprintf(usr_cnsl,"\t\t\t...but, hey - you can do what you want...\n");
      fprintf(usr_cnsl,"\n\t\t*********************************************************\n\n");     
    }

  /*************************** STAMPA AMBIENTE ***********************/

  if(DEBUG) fprintf(usr_cnsl,"wsmp3_accepted=%s\n",getenv("wsmp3_accepted"));
  if(logflag)
    {
      time(&tempo);
      fprintf(logfile,"%s wsmp3_accepted=%s\n",mytime(localtime(&tempo)),getenv("wsmp3_accepted"));
      fflush(logfile);
    }

  if(DEBUG) fprintf(usr_cnsl,"RootDIR=%s\n",rootdir);
  if(logflag)
    {
      time(&tempo);
      fprintf(logfile,"%s RootDIR=%s\n",mytime(localtime(&tempo)),rootdir);
      fflush(logfile);
    }

  /******************************INIZIALIZZAZIONE*********************/

  serverSocket=socket(AF_INET,SOCK_STREAM,0);
  serverAddr.sin_family=AF_INET;
  serverAddr.sin_port=htons(MYPORT);
  serverAddr.sin_addr.s_addr=INADDR_ANY;
  memset(&(serverAddr.sin_zero),0,8);

  bind(serverSocket,(struct sockaddr*)&serverAddr,sizeof(struct sockaddr));

  time(&tempo);
  fprintf(usr_cnsl,"%s",mytime(localtime(&tempo)));
  fprintf(usr_cnsl,"\n\t\t(l:%d,d:%d) %s (%s): ready to send!! :)\n\n",logflag,DEBUG,argv[0],VERSION);

  /***************************CICLO ATTESA***************************/

  listen(serverSocket,10);
  while(1)
    {
      clientAddrSize=sizeof(struct sockaddr_in);
      do
	{
	  sock=accept(serverSocket,(struct sockaddr*) &clientAddr,&clientAddrSize);
	}while ((sock==-1) && (errno==EINTR));
      if(sock==-1)
	{
	  fprintf(usr_cnsl,"Bad accept\n");
	  exit(1);
	}
      
      entity=gethostbyaddr((char*) &clientAddr.sin_addr,sizeof(struct in_addr),AF_INET);

      if(DEBUG) fprintf(usr_cnsl,"-------------------------\n");
      if(DEBUG) fprintf(usr_cnsl,"Connection from %s\n",inet_ntoa((struct in_addr) clientAddr.sin_addr));

      if(logflag)
	{
	  time(&tempo);
	  fprintf(logfile,"%s -------------------------\n",mytime(localtime(&tempo)));
	}
      if(logflag) 
	{
	  time(&tempo);
	  fprintf(logfile,"%s Connection from %s\n",
		  mytime(localtime(&tempo)),inet_ntoa((struct in_addr) clientAddr.sin_addr));
	}
      
      /************************SE NON RICEVO RICHIESTE => MENU PER TELNET********************/
      i=-1;
      time(&start_tempo);
      fcntl(sock,F_SETFL,O_NONBLOCK);
	    
      do
	{ 
	  i=recv(sock,recvBuffer,BUFSIZE,0);
	  if(i!=-1) break;
	  time(&tempo);
	  if((( (int)tempo - (int)start_tempo ))>5) break;
       }while(((int)tempo-(int)start_tempo)<5);

      if(i== -1)
	{

	  if(strcmp(inet_ntoa((struct in_addr) clientAddr.sin_addr),"127.0.0.1"))
	    {
	      sprintf(recvBuffer,"No connection from here outside of 127.0.0.1\n");
	      programWIDE_totalSent+=send(sock,recvBuffer,strlen(recvBuffer),0);
	      continue; //e' una maniera stupida di impedire accessi non autorizzati....
	    }

	  pidPassed=childPID=fork();
	  if(childPID==0)
	    { 
	      programWIDE_totalSent=0;
	      fnbf=1;
	      close(sock);
	      continue;
	    }
	  else
	    {
	      //sa_dontcare.sa_handler=SIG_IGN;      /*per non lasciare troppi processi zombie*/
	      sa_dontcare.sa_flags=SA_ONESHOT;
	      sa_dontcare.sa_handler=mychildexithandler;
	      //sa_dontcare.sa_flags=SA_NOCLDSTOP;   /*idem*/
	      sigaction(SIGCHLD,&sa_dontcare,NULL);/*idem*/

	      dupsock=dup(sock);
	      close(sock);
	      menu(&dupsock);
	      close(dupsock);
	      kill(childPID,SIGKILL);
	      fnbf=0;
	      continue;
	    }
	}

      if(PDEBUG) printf("i:%d\n",i);
      if(i==-1 || !i)
	{  
	  continue;
	}

      programWIDE_totalReceived+=i; //incremento il totale dei bytes in rx

      /********************************HO RICEVUTO RICHIESTE********************************/

      /*if(recvBuffer[i-1]!='\n') break;*/  //nostalgic comment... leave it where it is.... :)

      fcntl(sock,F_SETFL,O_APPEND);
      recvBuffer[i]='\0';

      if(DEBUG) fprintf(usr_cnsl,"Received from client: \n*****\n%s\n*****\n",recvBuffer);
      if(logflag) 
	{
	  time(&tempo);
	  fprintf(logfile,"%s Received from client: \n*****\n%s\n*****\n",
		  mytime(localtime(&tempo)),recvBuffer);
	  fflush(logfile);
	}

      conn_req=parse_request(recvBuffer);
      if(PDEBUG)printf("%s\n",print_req_descriptor(conn_req));
      for(i=0;i<BUFSIZE;i++) recvBuffer[i]='\0';
      if(PDEBUG) printf("recvBuffer svuotato: %s\n",recvBuffer);
     /*************************************** HAPPY MODE :) ************************************/      

      if(conn_req->agent!=NULL && (HAPPYMODE && 
				   ((strstr(conn_req->agent,"MSIE")||strstr(conn_req->agent,"indows"))||
				    strstr(conn_req->agent,"inNT"))
				  )
	)
	{
	  if(DEBUG) fprintf(usr_cnsl,"Be Happy! :)\n");
	  if(logflag)
	    {
	      time(&tempo);
	      fprintf(logfile,"%s Be Happy! :)\n",mytime(localtime(&tempo)));
	    } 
	  send(sock,HAPPYHEAD,strlen(HAPPYHEAD),0);	  
	  send(sock,HAPPYMSG,strlen(HAPPYMSG),0);
	  close(sock);
	  rem_req_descriptor(conn_req);
	  continue;
	}

      /***************************************DIRECTORY LIST************************************/

      if((conn_req->action!=NULL && !strcmp(conn_req->action,"GET"))
	 && 
	 (((cp2=strstr((cp=conn_req->what),"cmd:ls"))!=NULL||
	  (cp2=strstr((cp=conn_req->what),"cmd%3Als"))!=NULL)||
	  (cp2=strstr((cp=conn_req->what),"cmd_ls"))!=NULL) 
	 )
	{
	  *cp2='\0';
	  strcpy(arg,cp);
	  if(!strcmp(arg,"")) strcpy(arg,".");
       	  if(DEBUG) fprintf(usr_cnsl,"Request list:%s\n",arg);

	  if(logflag)
	    {
	      time(&tempo);
	      fprintf(logfile,"%s Request list:%s\n",mytime(localtime(&tempo)),arg);
	      fflush(logfile);
	    }

	  strcpy(conn_req->what,arg);
	  send_dir_list(sock,conn_req);
	  close(sock);
	  if(DEBUG) fprintf(usr_cnsl,"Connection closed by client.\n");
	} //inserire comandi????

      /***************************************    VERSION    ************************************/

      else if((conn_req->action!=NULL && !strcmp(conn_req->action,"GET"))
	      && 
	      (strstr(conn_req->what,"cmd:ver")!=NULL||
	       (strstr(conn_req->what,"cmd%3Aver")!=NULL||
		strstr(conn_req->what,"cmd_ver")!=NULL) 
	      )
	     )
	{
	  if(DEBUG) fprintf(usr_cnsl,"Version requested...\n");
	  if(logflag)
	    {
	      time(&tempo);
	      fprintf(logfile,"%s Version requested...\n",mytime(localtime(&tempo)));
	      fflush(logfile);
	    }

	  sprintf(recvBuffer,"HTTP/1.1 200 OK\nConnection: close\nContent/Type: text/html\n\n<HTML><HEAD><TITLE>WSMP3</TITLE><LINK rel=stylesheet href=\"/data/styles.css\" type=\"text/css\"></HEAD><BODY><DIV align=center class=testo>WsMp3 %s<BR>%s</DIV></BODY></HTML>",VERSION,AUTHOR);
	  programWIDE_totalSent+=send(sock,recvBuffer,strlen(recvBuffer),0);

	  if(DEBUG) fprintf(usr_cnsl,"Version sent.\n");
	  if(logflag)
	    {
	      time(&tempo);
	      fprintf(logfile,"%s Version sent.\n",mytime(localtime(&tempo)));
	      fflush(logfile);
	    }

	  close(sock);
	}
 
      /*************************************INVIO FLUSSI MP3*************************************/
      //bisogna trovare la stringa User-Agent per winamp ed altri mp3players

      else if((conn_req->action!=NULL && !strcmp(conn_req->action,"GET")) && 
	      (conn_req->agent!=NULL && strstr(conn_req->agent,"xmms")))
	{

	  if(fnbf) 
	    {
	      errstr=write_error_msg(conn_req,"please try again later\n");
	      send(sock,errstr,strlen(errstr),0);
	      close(sock);

	      if(DEBUG) fprintf(usr_cnsl,"Sent error:\n%s\n",errstr);
	      if(logflag)
		{ 
		  time(&tempo);
		  fprintf(logfile,"%s Sent error:\n%s\n",mytime(localtime(&tempo)),errstr);
		  fflush(logfile);
		}

	      continue;
	    }

	  pidPassed=childPID=fork();
	  if(childPID==0) 
	    {
	      programWIDE_totalReceived=0; //quando forko , nei processi figli i contatori sono resettati
	      programWIDE_totalSent=0;     //e poi aggiunti a quelli del padre
	      if(DEBUG) fprintf(usr_cnsl,"Parent: PID %d, Child: PID %d\n",getppid(),getpid());
	      if(logflag)
		{ 
		  time(&tempo);
		  fprintf(logfile,"%s Parent: PID %d, Child: PID %d\n",
			   mytime(localtime(&tempo)),getppid(),getpid());
		}
	      if(conn_req->what[strlen(conn_req->what)-1]=='/') read_mp3_dir(conn_req,&sock);
	      else read_mp3_file(conn_req,&sock);
	      close(sock);
	      if(DEBUG) fprintf(usr_cnsl,"Connection closed by client.\n");
	      if(logflag)
		{ 
		  time(&tempo);
		  fprintf(logfile,"%s Connection closed by client.\n",mytime(localtime(&tempo)));
		  fflush(logfile);
		}
	      sprintf(recvBuffer,"%d/%d",programWIDE_totalReceived,programWIDE_totalSent);
	      sprintf(filename,"wsmp3_result_bytes.tmp");
	      tf=fopen(filename,"w");
	      fwrite(recvBuffer,strlen(recvBuffer),1,tf);
	      fclose(tf);
	      exit(0);
	    }
	  else
	    { 
	      close(sock);  
	      if(DEBUG) fprintf(usr_cnsl,"Sending music in background....\n");
	      if(logflag)
		{ 
		  time(&tempo);
		  fprintf(logfile,"%s Sending music in background....\n",mytime(localtime(&tempo)));
		  fflush(logfile);
		}
	      sa_dontcare.sa_flags=SA_NOCLDSTOP; /*per non lasciare troppi processi zombie*/
	      sa_dontcare.sa_handler=mychildexithandler;
	      sigaction(SIGCHLD,&sa_dontcare,NULL);/*idem*/
	    }
	}

      /***************************************INVIO FILES*************************************/

      else if(conn_req->action!=NULL &&!strcmp(conn_req->action,"GET"))
	{  
	  if(shallIfork(conn_req->what)) 
	  {
	    if(fnbf) 
	      {
		errstr=write_error_msg(conn_req,"please try again later\n");
		send(sock,errstr,strlen(errstr),0);
		close(sock);
		
		if(DEBUG) fprintf(usr_cnsl,"Sent error:\n%s\n",errstr);
		if(logflag)
		  { 
		    time(&tempo);
		    fprintf(logfile,"%s Sent error:\n%s\n",mytime(localtime(&tempo)),errstr);
		    fflush(logfile);
		  }
		
		continue;
	      }

	  if(DEBUG) fprintf(usr_cnsl,"...must fork, filename:%s\n",conn_req->what);

	  if(logflag)
	    { 
	      time(&tempo);
	      fprintf(logfile,"%s ...must fork, filename:%s\n",
		      mytime(localtime(&tempo)),conn_req->what);
	    }

	  pidPassed=childPID=fork();
	  if(childPID==0) 
	    {
	      programWIDE_totalReceived=0; //quando forko , nei processi figli i contatori sono resettati
	      programWIDE_totalSent=0;     //e poi aggiunti a quelli del padre
	      if(DEBUG) fprintf(usr_cnsl,"Parent: PID %d, Child: PID %d\n",getppid(),getpid());
	      if(logflag)
		{ 
		  time(&tempo);
		  fprintf(logfile,"%s Parent: PID %d, Child: PID %d\n",
			  mytime(localtime(&tempo)),getppid(),getpid());
		}

	      if(strstr(conn_req->what,".htm")) read_html_file(conn_req,&sock);
	      else read_any_file(conn_req,&sock);
	      close(sock);
	      if(DEBUG) fprintf(usr_cnsl,"Connection closed by client.\n");
	      if(logflag)
		{ 
		  time(&tempo);
		  fprintf(logfile,"%s Connection closed by client.\n",mytime(localtime(&tempo)));
		  fflush(logfile);
		}
	      sprintf(recvBuffer,"%d/%d",programWIDE_totalReceived,programWIDE_totalSent);
	      sprintf(filename,"wsmp3_result_bytes.tmp");
	      tf=fopen(filename,"w");
	      fwrite(recvBuffer,strlen(recvBuffer),1,tf);
	      fclose(tf);
	      exit(0);
	    }
	  else
	    { 
	      close(sock);  
	      if(DEBUG) fprintf(usr_cnsl,"Sending in background....\n");
	      if(logflag)
		{ 
		  time(&tempo);
		  fprintf(logfile,"%s Sending in background....\n",mytime(localtime(&tempo)));
		  fflush(logfile);
		}

	      sa_dontcare.sa_flags=SA_NOCLDSTOP;  /*per non lasciare troppi processi zombie*/
	      sa_dontcare.sa_handler=mychildexithandler;
	      sigaction(SIGCHLD,&sa_dontcare,NULL);/*idem*/
	    }
	}
	else 
	  {
	    if(DEBUG) fprintf(usr_cnsl,"...don't need to fork, PID:%d\n",getpid());
	    if(logflag)
	      {
		time(&tempo);
		fprintf(logfile,"%s ...don't need to fork, PID:%d\n",mytime(localtime(&tempo)),getpid());
	      }
	    
	    if(!strcmp(conn_req->what,"")||conn_req->what[strlen(conn_req->what)-1]=='/')
	      { 
		strcat(conn_req->what,"index.htm");

		if(DEBUG) fprintf(usr_cnsl,"sending default page\n");
		if(logflag)
		  {
		    time(&tempo);
		    fprintf(logfile,"%s sending default page\n",mytime(localtime(&tempo)));
		  }
		read_html_file(conn_req,&sock);
	      }
	    else if(strstr(conn_req->what,".htm")) read_html_file(conn_req,&sock);
	    else read_any_file(conn_req,&sock);

	    close(sock);
	    if(DEBUG) fprintf(usr_cnsl,"Connection closed by client.\n");
	    if(logflag)
	      { 
		time(&tempo);
		fprintf(logfile,"%s Connection closed by client.\n",mytime(localtime(&tempo)));
		fflush(logfile);
	      }
	  }
	}

      /*****************************************CGI-BIN************************************/
      
      else if((conn_req->action!=NULL) && !strcmp(conn_req->action,"POST"))
	{
	  if(conn_req->what!=NULL && (tf=fopen(conn_req->what,"r"))==NULL)
	    { 
	      errstr=write_error_msg(conn_req,"Not implemented");
	      send(sock,errstr,strlen(errstr),0);
	      close(sock);
	      if(DEBUG) fprintf(usr_cnsl,"CGI_BIN [%s] not found.\nSent error: %s",
				conn_req->what,errstr);
	      if(logflag)
		{
		  time(&tempo);
		  fprintf(logfile,"%s CGI-BIN [%s] not found.\nSent error: %s",
			  mytime(localtime(&tempo)),conn_req->what,errstr);
		  fflush(logfile);
		}
	    }
	  else
	    {
	      fclose(tf);
	      pidPassed=childPID=fork();
	      if(childPID==0) 
		{
		  programWIDE_totalReceived=0; //i contatori sono resettati
		  programWIDE_totalSent=0;

		  arg2[0]=conn_req->what;
		  arg2[1]=conn_req->content;
		  arg2[2]=NULL;
		  fclose(stdout);
		  stdout=tmpfile();
		  if(stdout==NULL)
		    {
		      stdout=fopen("/dev/tty","a");
		      n_errno=errno;
		      if(DEBUG) fprintf(usr_cnsl,"tmpfile: %s\n",sys_errlist[n_errno]);
		      if(logflag)
			{
			  time(&tempo);
			  fprintf(logfile,"%s tmpfile:%s\n",
				  mytime(localtime(&tempo)),
				  sys_errlist[n_errno]);
			  fflush(logfile);
			  n_errno=-1;
			}
		      exit(0);
		    }
		  childPID=fork();
		  if(childPID==0)
		    {
		      execv(conn_req->what,arg2);
		      exit(0);
		    }
		  else
		    {		  
		      waitpid(childPID,NULL,0);
		      dread_html_file(stdout,&sock);
		      fclose(stdout);
		      stdout=fopen("/dev/tty","a");
		      if(DEBUG) fprintf(usr_cnsl,"CGI-BIN [%s] Done.\n",conn_req->what);
		      if(logflag)
			{
			  time(&tempo);
			  fprintf(logfile,"%s CGI-BIN [%s] Done.\n",
				  mytime(localtime(&tempo)),
				  conn_req->what);
			  fflush(logfile);
			}
		      /*********per prova***************
		      childPID=fork();
		      if(childPID==0)
			{
			  execve(conn_req->what,arg2,environ);
			  exit(0);
			}
		      else
			{
			  waitpid(childPID,NULL,0);
			}
		       ********************************/
		      close(sock);
		    } 
		  sprintf(recvBuffer,"%d/%d",programWIDE_totalReceived,programWIDE_totalSent);
		  sprintf(filename,"wsmp3_result_bytes.tmp");
		  tf=fopen(filename,"w");
		  fwrite(recvBuffer,strlen(recvBuffer),1,tf);
		  fclose(tf);
		  exit(0);
		}
	      else
		{
		  close(sock);
		  if(DEBUG) fprintf(usr_cnsl,"Sending CGI-BIN\n");
		  if(logflag)
		    {
		      time(&tempo);
		      fprintf(logfile,"%s Sending CGI-BIN\n",mytime(localtime(&tempo)));
		      fflush(logfile);
		    }
		  sa_dontcare.sa_flags=SA_NOCLDSTOP;  /*per non lasciare troppi processi zombie*/
		  sa_dontcare.sa_handler=mychildexithandler;
		  sigaction(SIGCHLD,&sa_dontcare,NULL);/*idem*/
		}
	    }
	}

      /******************************************CHAT***************************************/

      else if((conn_req->action!=NULL && !strcmp(conn_req->action,"CHA")) && CHATMODE)
	{
	  for(chati=0;chati<1024;chati++) chatbuf[chati]='\0';
	  fprintf(usr_cnsl,"[%s] %s\n> ",inet_ntoa((struct in_addr) clientAddr.sin_addr),conn_req->what);
	  fgets(chatbuf,1024,stdin);
	  if(chatbuf[strlen(chatbuf)-1]=='\n') chatbuf[strlen(chatbuf)-1]='\0';
	  chatbuf[1023]='\0';
	  send(sock,chatbuf,strlen(chatbuf),0);
	  close(sock);
	  if(logflag)
	    {
	      time(&tempo);
	      fprintf(logfile,"%s CHAT MESSAGE SENT: [%s]\n",mytime(localtime(&tempo)),chatbuf);
	      fflush(logfile);
	    }
	}

      /********************************** ping-WsMp3 *****************************************/
      
      else if(conn_req->action!=NULL && !strcmp(conn_req->action,"ping-WsMp3?"))
	{
	  for(chati=0;chati<1024;chati++) chatbuf[chati]='\0';
	  sprintf(chatbuf,"WsMp3:%s\n",VERSION);
	  send(sock,chatbuf,strlen(chatbuf),0);
	  close(sock);
	  if (DEBUG) fprintf(usr_cnsl,"Pong...\n");
	  if(logflag)
	    {
	      time(&tempo);
	      fprintf(logfile,"%s Pong...\n",mytime(localtime(&tempo)));
	      fflush(logfile);
	    }
	}

      /***************************************************************************************/
      else
	{ 
	  if(DEBUG) printf("don't know what to do....\n"); 
	  if(logflag)
	    {
	      time(&tempo);
	      fprintf(logfile,"%s don't know what to do...\n",mytime(localtime(&tempo)));
	      fflush(logfile);
	    }
	}
      rem_req_descriptor(conn_req); //elimina la richiesta
    }
  return 0;
}

/*
 * restituisce una data in formato stringa
 */
char *mytime(struct tm *src)
{
  char *str;
  char *mesi[]={"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};
  char *giorni[]={"Sun","Mon","Tue","Wed","Thu","Fri","Sat"};

                      /*
	              struct tm {
                      int     tm_sec;          seconds 
                      int     tm_min;          minutes
                      int     tm_hour;         hours 
                      int     tm_mday;         day of the month 
                      int     tm_mon;          month 
                      int     tm_year;         year 
                      int     tm_wday;         day of the week 
                      int     tm_yday;         day in the year 
                      int     tm_isdst;        daylight saving time 
		      };*/

  str=malloc(30);
  sprintf(str,"%s %s %02d %02d:%02d:%02d %d%c",giorni[src->tm_wday],mesi[src->tm_mon],src->tm_mday,src->tm_hour,src->tm_min,src->tm_sec,1900+src->tm_year,'\0');
  return str;
}
